javax.ws.rs.client

## Interface InvocationCallback<RESPONSE>

- Type Parameters:
    `RESPONSE` - response type. It can be either a general-purpose `Response` or the anticipated response entity type.

      public interface InvocationCallback<RESPONSE>

  Callback that can be implemented to receive the asynchronous processing events from the invocation processing.
  Since:
    2.0
  Author:
    Marek Potociar

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `completed(RESPONSE response)` Called when the invocation was successfully completed.
    `void` | `failed(Throwable throwable)` Called when the invocation has failed for any reason.

- - ### Method Detail

    - #### completed

          void completed(RESPONSE response)

      Called when the invocation was successfully completed. Note that this does not necessarily mean the response has bean fully read, which depends on the parameterized invocation callback response type.

      Once this invocation callback method returns, the underlying `Response` instance will be automatically closed by the runtime.

      Parameters:
        `response` - response data.

    - #### failed

          void failed(Throwable throwable)

      Called when the invocation has failed for any reason.

      Note that the provided `Throwable` may be a `ProcessingException` in case the invocation processing failure has been caused by a client-side runtime component error. The `Throwable` may also be a `WebApplicationException` or one of its subclasses in case the response status code is not `successful` and the generic callback type is not `Response`. In case a processing of a properly received response fails, the wrapped processing exception will be of `ResponseProcessingException` type and will contain the `Response` instance whose processing has failed. A `CancellationException` would be indicate that the invocation has been cancelled. An `InterruptedException` would indicate that the thread executing the invocation has been interrupted.

      Once this invocation callback method returns, the underlying `Response` instance will be automatically closed by the runtime.

      Parameters:
        `throwable` - contains failure details.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.